#include "djumbai_enqueue.h"
#include <stdlib.h>

int main() {

    printf("RUNNING AS UID: %d, EUID %d, GID %d, and EGID %d\n",getuid(),geteuid(),getgid(),getegid());
	const char *message_queue_path =
		"/djumbai/fifos/message_queue";

    //Check if I have write permissions on the FIFO
    if (faccessat(AT_FDCWD, message_queue_path,W_OK,AT_EACCESS) != -1) {
        printf("You have write access to the FIFO.\n");
    } else {
        perror("Error");
        exit(EXIT_FAILURE);
    }

	// Open the FIFO for writing
	int queue_fd;
	queue_fd = open(message_queue_path, O_WRONLY);
	if (queue_fd == -1) {
		if (errno == ENOENT) {
			// FIFO does not exist
			printf("FIFO '%s' does not exist. Exiting...\n", message_queue_path);
			return 1;
		} else {
			perror("open");
			return 1;
		}
	}

	// Read message from stdin
	unsigned char buffer[MESSAGE_SIZE];
	read(0, buffer, MESSAGE_SIZE);

	// Write message to message queue
	write(queue_fd, buffer, MESSAGE_SIZE);
    close(queue_fd);
}
